/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) <year>  <name of author>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/

#ifndef KMFILE_H
#define KMFILE_H
#include <kprocess.h>
#include <qtreewidget.h>
#include <qtimer.h>
#include <qfile.h>
#include <qsocketnotifier.h>

#include <kconfiggroup.h>

class KmFile
{

public:
	KmFile();
	
	virtual ~KmFile();
	
	bool operator== ( const KmFile &other ) const;
	
	QString 			mFileNm;
	QString 			mName;
	QString				mFilter;
	QString				mPattern;
	QString				mTemplate;
	QTreeWidget 	*mpTW;
	QTimer				*mpTimer;
	QFile  				*mpSocket;
	KConfigGroup  *mpPropsGroup;
	bool					mNoTmplt;
	int						mMsgFieldCnt;

private:
};

class KmFileList
{
public:
	KmFileList();
	virtual ~KmFileList();
	
	KmFile* file( const int k );
	int count() const;
	KmFile* addFile( const KmFile& rFile );
	void addFileMap( const QString&, KmFile* );
	void addObjMap( KProcess*, KmFile* );
	void addObjMap( QTimer*, KmFile* );
	bool containsFile( const QString& ) const;
	KmFile* fileMap( const QString& s );
	int indexOf( KmFile& ) const;
	KmFile* objMap( QObject* pSender );
	void move( int, int );
	void removeFile( const KmFile& vm );
	void removeFileMap( const QString& );
	void removeObjMap( KProcess* );
	void removeObjMap( QTimer* );
	QStringList fileNames() const;

private:	
	QList<KmFile> mFiles;
	QStringList mFileNames;
	QHash<QObject*, KmFile*> mMapObject;
	QHash<QString, KmFile*> mMapFile;
};

#endif // KMFILE_H
